import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Stack;

public class AriadneIterator implements Iterator<Room>{
    private Room entry;
    private Stack<Room> ariadnesThread;
    private List<Room> visited;

    private State currentstate;

    public AriadneIterator(Room entry) {
        this.entry = entry;
    }

    
    @Override
    public boolean hasNext() {
        return cs.hasNext();
    }

    @Override
    public Room next() {
        return ariadnesThread.peek();
    }

    public void stepRetreating() {
        ariadnesThread.pop();
    }
    
    public boolean hasMinotaur() {
        return ariadnesThread.peek().getMinotaur();
    }

    public void step() {
        currentstate.step();
    }

    public void init() {
        ariadnesThread = new Stack<>();
        ariadnesThread.push(entry);
        visited = new ArrayList<>();
        visited.add(entry);
        currentstate = new Starting();
    }

    private class Starting implements State {
        @Override
        public void step() {
            init();
        }

        @Override
        public boolean hasNext() {
           return false;
        }
    }

    private class Accomplished implements State {
        @Override
        public void step() {
            stepRetreating();
        }

        public boolean hasNext() {
            return !ariadnesThread.empty();
        }
    }


}
